/* ONE_ON_NINE.C - From page 75 of Volume 4, Number 2, the February    */
/* 1987 issue of Computer Language. The article is by Jean-Pierre      */
/* Schachter and is entitled DATA STRUCTURES AND SCROLLING.            */
/*                                                                     */
/* Usage:   A>one_on_9 <RET>                                           */
/***********************************************************************/

#define REQUEST (request = get_scan())
#define FINISHED 1
#define MOVE_LEFT case 75
#define MOVE_RIGHT case 77
#define MOVE_UP case 72
#define MOVE_DOWN case 80
#define RIGHT --pb
#define LEFT ++pb
#define DOWN pb -= 240
#define UP pb += 240
#define TO_CENTER pb += 6080
#define IS ==
#define IS_NOT !=
#define SHOULD switch
#define BE
#define BEEP 7
#define CLRSCR puts(clrscr)

#include <stdio.h>
#include <malloc.h>
#include <memory.h>
#include <conio.h>
#include <dos.h>

char *pb, *line[25];

main()
{
static char clrscr[] = { 27, "[2J\0" };

   pb = memset(malloc (18000), ' ', 18000);
   CLRSCR;
   move_it(TO_CENTER);        /* CENTERS DISPLAY ON V. SCR.     */
   mess_it();                 /* WRITES JUNK TO V. SCR.         */
   show_it();                 /* DISPLAYS THE V. SCREEN         */
   scrl_it();                 /* SCROLLS THE DISPLAY            */
   CLRSCR;
   exit(0);
}

/* ================== Function scrl_it() =======================*/

scrl_it()      /* THE READ AND INTERRUPT LOOP */
{
char request = 0, income();

   while (REQUEST IS_NOT FINISHED) {
      SHOULD (request) BE {
         MOVE_RIGHT:
            move_it(RIGHT);
            show_it();
            break;
         MOVE_LEFT:
            move_it(LEFT);
            show_it();
            break;
         MOVE_UP:
            move_it(UP);
            show_it();
            break;
         MOVE_DOWN:
            move_it(DOWN);
            show_it();
            break;
         default:
            putchar(7);
            